<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/passengerInfo">乘客管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form
      ref="queryForm"
      :model="queryModel"
      inline
      class="demo-form-inline"
    >
      <el-form-item label="车辆人员编号" prop="vehiclePersonId">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.vehiclePersonId"
        ></el-input>
      </el-form-item>
      <el-form-item label="注册用户名称" prop="userName">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.userName"
        ></el-input>
      </el-form-item>
      <el-form-item
        label="购票状态"
        prop="payStatus"
      >
        <!-- <el-select
          v-model="queryModel.payStatus"
          filterable
          clearable
          placeholder="请选择"
          style="width: 110px"
          size="mini"
        >
          <el-option key="0" label="未购票" value="0"></el-option>
          <el-option key="1" label="已购票" value="1"></el-option>
          <el-option key="2" labe value="2"></el-option>
          <el-option key="3" label="已l="已国战"补票" value="3"></el-option>
        </el-select> -->

        <el-select v-model="queryModel.payStatus" size="mini" style="width:110px;">
          <el-option v-for="(item,index) in payStatusList" 
          :label="item.name" :value="item.value" :key="index"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <!-- <el-row class="button-group">
      
    </el-row> -->
    <el-table
      :data="tableData"
      style="min-height: 400px"
      v-loading="loading"
      stripe
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column
          type="index"
          label="序号"
          :index="indexMethod"
          width="50"
        ></el-table-column>
        <el-table-column prop="status" label="乘车状态" width="100">
          <template slot-scope="{ row }">
            <span v-if="row.status == 0">未乘车</span>
            <span v-else-if="row.status == 1">上车</span>
            <span v-else-if="row.status == 2">下车</span>
          </template>
        </el-table-column>
        <el-table-column prop="payStatus" label="购票状态" width="100">
          <template slot-scope="{ row }">
            <span v-if="row.payStatus == 0" style="color:red">未购票</span>
            <span v-else-if="row.payStatus == 1">已购票</span>
            <span v-else-if="row.payStatus == 2" style="color:red">已过站</span>
            <span v-else-if="row.payStatus == 3">已补票</span>
          </template>
        </el-table-column>
        <el-table-column
          prop="payName"
          label="购票方式"
          width="100"
        ></el-table-column>
        <el-table-column
          prop="vehiclePersonId"
          label="车辆人员编号"
          width="150"
        ></el-table-column>
        <el-table-column
          prop="userName"
          label="注册用户"
          width="150"
        ></el-table-column>
        <el-table-column prop="imageUrl" label="乘车人照片" width="120">
          <template slot-scope="{ row }">
            <a v-if="row.imageUrl" :href="row.imageUrl" target="_blank">
              <el-image
                :size="50"
                :src="
                  row.imageUrl + '?x-oss-process=image/resize,m_fill,w_54,h_54'
                "
                :key="row.id"
              ></el-image>
            </a>
          </template>
        </el-table-column>
        <el-table-column
          prop="ticketUpStationName"
          label="购票上车站点"
          width="180"
        ></el-table-column>
        <el-table-column
          prop="upStationName"
          label="上车站点"
          width="180"
        ></el-table-column>
        <el-table-column
          prop="ticketDownStationName"
          label="购票下车站点"
          width="180"
        ></el-table-column>
        <el-table-column
          prop="downStationName"
          label="下车站点"
          width="180"
        ></el-table-column>
        <el-table-column
          prop="upTime"
          label="上车时间"
          width="180"
        ></el-table-column>
        <el-table-column
          prop="downTime"
          label="下车时间"
          width="180"
        ></el-table-column>
        <el-table-column
          prop="createTime"
          label="创建时间"
          width="180"
        ></el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
  </div>
</template>
<script>
import Constant from "@/constant";
import passengerInfoApi from "@/api/bus/passengerInfo";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style
import dataDictionaryApi from "@/api/sys/dataDictionary";

export default {
  name: "BusPassengerInfoList",
  data() {
    var self = this;

    return {
      queryModel: {
        vehicleShiftId: "",
        vehiclePersonId: "",
        userId: "",
        userName: "",
        status: "",
        payStatus: "",
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      modalTitle: "",
      businessKey: "",
      payStatusList:[],
    };
  },
  created() {
    dataDictionaryApi.findByCatalogName({
      "catalogName" : "购票状态"
    }).then(response => {
      var jsonData = response.data;
      this.payStatusList = jsonData.data;
    });
  },
  methods: {
    indexMethod(index) {
      return (this.pageIndex - 1) * this.pageSize + (index + 1);
    },
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("vehicleShiftId", self.queryModel.vehicleShiftId);
      formData.append("vehiclePersonId", self.queryModel.vehiclePersonId);
      formData.append("userId", self.queryModel.userId);
      formData.append("userName", self.queryModel.userName);
      formData.append("status", self.queryModel.status);
      formData.append("payStatus", self.queryModel.payStatus);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      passengerInfoApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          passengerInfoApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        passengerInfoApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
  },
  mounted: function () {
    this.changePage(1);
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>